/*
 * Copyright (c) 1993 NeXT Computer, Inc.
 *
 * ISA/EISA device description class.
 *
 * HISTORY
 *
 * 18Jan93 Brian Pinkerton at NeXT
 *	Created.
 *
 */
#import <driverkit/IODeviceDescription.h>
#import <driverkit/driverTypes.h>


@interface IOEISADeviceDescription : IODeviceDescription
{
@private
	void	*_kernDev;
}

- (unsigned int) interrupt;
- (unsigned int) channel;

- (unsigned int *) interruptList;
- (unsigned int) numInterrupts;
- (unsigned int *) channelList;
- (unsigned int) numChannels;
- (IORange *) portRangeList;
- (unsigned int) numPortRanges;
- (IORange *) memoryRangeList;
- (unsigned int) numMemoryRanges;

- (void) setInterruptList	: (unsigned int *)list 
		    	    num : (unsigned int) numInterrupts;
- (void) setChannelList		: (unsigned int *)list 
			    num : (unsigned int) numChannels;
- (void) setPortRangeList	: (IORange *)list 
			    num : (unsigned int) numRanges;
- (void) setMemoryRangeList	: (IORange *)list
			    num : (unsigned int) numRanges;

@end
